const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const time_entries = sequelize.define(
    'time_entries',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      date: {
        type: DataTypes.DATE,
      },

      start: {
        type: DataTypes.DATE,
      },

      end: {
        type: DataTypes.DATE,
      },

      break_minutes: {
        type: DataTypes.INTEGER,
      },

      job_code: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  time_entries.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.time_entries.belongsTo(db.timecards, {
      as: 'timecard',
      foreignKey: {
        name: 'timecardId',
      },
      constraints: false,
    });

    db.time_entries.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.time_entries.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.time_entries.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return time_entries;
};
